{
  description = "Patched peertube";
  inputs.peertube_origin = {
    path = "../../peertube";
    type = "path";
  };
  inputs.peertube_syden = {
    path = "../../peertube";
    type = "path";
    inputs.peertube = {
      url = "https://git.immae.eu/github/Chocobozzz/PeerTube.git";
      ref = "gitolite_local/syden";
      flake = false;
      type = "git";
    };
  };

  outputs = { self, peertube_origin, peertube_syden }: {
    overlays = {
      peertube_syden = final: prev: { peertube_syden = peertube_syden.defaultPackage."${final.system}"; };
      peertube_origin = final: prev: { peertube_origin = peertube_origin.defaultPackage."${final.system}"; };
    };
    packages.x86_64-linux.peertube = peertube_origin.packages.x86_64-linux.peertube;
    packages.x86_64-linux.peertube_syden = peertube_syden.packages.x86_64-linux.peertube;
    defaultPackage.x86_64-linux = peertube_origin.defaultPackage.x86_64-linux;
    nixosModule = peertube_origin.nixosModule;
  };
}
