{ lib, config, ... }@args:
{
  options.myEnv = (import ../../../environment.nix (args // { name = "dummy"; })).options.myEnv;
  config = {
    fileSystems."/".device = "/dev/disk/by-label/nixos";
    boot.initrd.availableKernelModules = [ "xhci_pci" "ehci_pci" "ahci" "usbhid" "usb_storage" "sd_mod" "virtio_balloon" "virtio_blk" "virtio_pci" "virtio_ring" ];
    boot.loader = {
      grub = {
        version = 2;
        device = "/dev/vda";
      };
      timeout = 0;
    };
    services.openssh.enable = true;
    networking.firewall.allowedTCPPorts = [ 22 ];
    users = {
      mutableUsers = false;
      users.root.openssh.authorizedKeys.keys = [ config.myEnv.sshd.rootKeys.immae_dilion ];
    };
  };
}
