{ environment, varDir, secretsPath
, composerEnv, fetchurl, sources }:
let
  app = composerEnv.buildPackage (
    import ./php-packages.nix { inherit composerEnv fetchurl; } //
    rec {
      version = sources.websites-florian-app.version;
      pname = "tellesflorian";
      name = "${pname}-${version}";
      src = sources.websites-florian-app;
      noDev = (environment == "prod");
      preInstall = ''
        export SYMFONY_ENV="${environment}"
        '';
      postInstall = ''
        cd $out
        rm app/config/parameters.yml
        ln -sf ${secretsPath} app/config/parameters.yml
        rm -rf var/{logs,cache}
        ln -sf ${varDir}/var/{logs,cache,sessions} var/
        '';
      passthru = {
        inherit varDir environment;
        webRoot = "${app}/web";
      };
    });
in app
