{ lib, pkgs, config,  ... }:
let
  cfg = config.myServices.websites.ressourcerie_banon.cloud;
  nextcloud = config.myServices.tools.cloud.farm.package;
in {
  options.myServices.websites.ressourcerie_banon.cloud.enable = lib.mkEnableOption "enable Ressourcerie Banon’s cloud";

  config = lib.mkIf cfg.enable {
    myServices.tools.cloud.farm.instances = [ "ressourcerie_banon" ];
    services.websites.env.production.modules = [ "proxy_fcgi" ];
    services.websites.env.production.vhostConfs.ressourcerie_banon_cloud = {
      certName     = "ressourcerie_banon";
      addToCerts   = true;
      hosts        = ["cloud.le-garage-autonome.org"];
      root         = nextcloud;
      extraConfig  = [ config.myServices.tools.cloud.farm.vhosts.ressourcerie_banon ];
    };
  };
}

