{ pkgs ? import <nixpkgs> { overlays = builtins.attrValues (import ./overlays); },
  pkgs-nix ? import <nixpkgs-nix> { overlays = builtins.attrValues (import ./overlays); }
}:
let
  patchedNix = pkgs-nix.nixUnstable.overrideAttrs(old: {
    patches = old.patches ++ [
      # Fix the ETag bug. PR merged. Remove when updating to >= 20210125
      # https://github.com/NixOS/nixpkgs/pull/109309#issuecomment-768331750
      (pkgs-nix.fetchpatch {
        url = "https://patch-diff.githubusercontent.com/raw/NixOS/nix/pull/4470.diff";
        sha256 = "sha256-d4RNOKMxa4NMbFgYcqWRv2ByHt8F/XUWV+6P9qHz7S4=";
      })
    ];
  });
in
pkgs.mkShell {
  buildInputs = [ patchedNix pkgs.sops pkgs.morph pkgs.niv pkgs.curl pkgs.shellcheck pkgs.jq pkgs.gnumake pkgs.yq ];
}
